/**
 * generated by Xtext 2.16.0
 */
package org.protelis.parser.scoping;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.function.Consumer;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.xtext.common.types.JvmOperation;
import org.eclipse.xtext.common.types.JvmType;
import org.eclipse.xtext.naming.QualifiedName;
import org.eclipse.xtext.resource.EObjectDescription;
import org.eclipse.xtext.resource.IEObjectDescription;
import org.eclipse.xtext.scoping.IScope;
import org.eclipse.xtext.scoping.Scopes;
import org.eclipse.xtext.scoping.impl.MapBasedScope;
import org.eclipse.xtext.scoping.impl.SimpleScope;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.protelis.parser.protelis.Block;
import org.protelis.parser.protelis.Call;
import org.protelis.parser.protelis.FunctionDef;
import org.protelis.parser.protelis.Import;
import org.protelis.parser.protelis.ImportDeclaration;
import org.protelis.parser.protelis.ImportSection;
import org.protelis.parser.protelis.Lambda;
import org.protelis.parser.protelis.ProtelisModule;
import org.protelis.parser.protelis.Rep;
import org.protelis.parser.protelis.Statement;
import org.protelis.parser.protelis.VarDef;
import org.protelis.parser.protelis.VarDefList;
import org.protelis.parser.protelis.VarUse;
import org.protelis.parser.scoping.AbstractProtelisScopeProvider;

/**
 * This class contains custom scoping description.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#scoping
 * on how and when to use it.
 */
@SuppressWarnings("all")
public class ProtelisScopeProvider extends AbstractProtelisScopeProvider {
  @Override
  public IScope getScope(final EObject context, final EReference reference) {
    IScope _xifexpression = null;
    if ((context instanceof VarUse)) {
      _xifexpression = this.scope_VarUse_reference(((VarUse)context), reference);
    } else {
      IScope _xifexpression_1 = null;
      if ((context instanceof Call)) {
        IScope _xblockexpression = null;
        {
          EObject global = ((Call)context).eContainer();
          while ((!(global instanceof ProtelisModule))) {
            global = global.eContainer();
          }
          _xblockexpression = this.scope_Call_reference(((ProtelisModule) global), reference);
        }
        _xifexpression_1 = _xblockexpression;
      } else {
        _xifexpression_1 = super.getScope(context, reference);
      }
      _xifexpression = _xifexpression_1;
    }
    return _xifexpression;
  }
  
  public IScope scope_VarUse_reference(final VarUse expression, final EReference ref) {
    IScope _xblockexpression = null;
    {
      final ArrayList<VarDef> list = new ArrayList<VarDef>();
      EObject container = expression.eContainer();
      while ((container != null)) {
        {
          boolean _matched = false;
          if (container instanceof Block) {
            _matched=true;
            Statement _first = ((Block)container).getFirst();
            if ((_first instanceof VarDef)) {
              Statement _first_1 = ((Block)container).getFirst();
              list.add(((VarDef) _first_1));
            }
          }
          if (!_matched) {
            if (container instanceof FunctionDef) {
              _matched=true;
              VarDefList _args = ((FunctionDef)container).getArgs();
              boolean _tripleNotEquals = (_args != null);
              if (_tripleNotEquals) {
                list.addAll(((FunctionDef)container).getArgs().getArgs());
              }
            }
          }
          if (!_matched) {
            if (container instanceof Lambda) {
              _matched=true;
              final EObject lambdaArgs = ((Lambda)container).getArgs();
              boolean _matched_1 = false;
              if (lambdaArgs instanceof VarDef) {
                _matched_1=true;
                list.add(((VarDef)lambdaArgs));
              }
              if (!_matched_1) {
                if (lambdaArgs instanceof VarDefList) {
                  _matched_1=true;
                  list.addAll(((VarDefList)lambdaArgs).getArgs());
                }
              }
            }
          }
          if (!_matched) {
            if (container instanceof Rep) {
              _matched=true;
              list.add(((Rep)container).getInit().getX());
            }
          }
          if (!_matched) {
            if (container instanceof VarDef) {
              _matched=true;
              list.add(((VarDef)container));
            }
          }
          if (!_matched) {
            if (container instanceof ProtelisModule) {
              _matched=true;
              return MapBasedScope.createScope(this.scope_Call_reference(((ProtelisModule)container), ref), Scopes.scopeFor(list).getAllElements());
            }
          }
          container = container.eContainer();
        }
      }
      _xblockexpression = Scopes.scopeFor(Collections.<EObject>emptyList());
    }
    return _xblockexpression;
  }
  
  public IScope scope_Call_reference(final ProtelisModule model, final EReference ref) {
    IScope _xblockexpression = null;
    {
      EList<FunctionDef> _definitions = model.getDefinitions();
      final List<EObject> internal = new ArrayList<EObject>(_definitions);
      final List<IEObjectDescription> externalProtelis = new ArrayList<IEObjectDescription>();
      final List<IEObjectDescription> java = new ArrayList<IEObjectDescription>();
      final Consumer<Import> _function = (Import it) -> {
        final String moduleName = it.getModule().getName();
        final Function1<FunctionDef, Boolean> _function_1 = (FunctionDef it_1) -> {
          return Boolean.valueOf(it_1.isPublic());
        };
        final Consumer<FunctionDef> _function_2 = (FunctionDef it_1) -> {
          externalProtelis.add(ProtelisScopeProvider.generateDescription(it_1.getName(), it_1));
          String _name = it_1.getName();
          String _plus = ((moduleName + ":") + _name);
          externalProtelis.add(ProtelisScopeProvider.generateDescription(_plus, it_1));
        };
        IterableExtensions.<FunctionDef>filter(it.getModule().getDefinitions(), _function_1).forEach(_function_2);
      };
      model.getProtelisImport().forEach(_function);
      final ImportSection javaImports = model.getJavaimports();
      if ((javaImports != null)) {
        final Consumer<ImportDeclaration> _function_1 = (ImportDeclaration id) -> {
          final JvmType type = id.getImportedType();
          final Function1<EObject, Boolean> _function_2 = (EObject it) -> {
            return Boolean.valueOf((it instanceof JvmOperation));
          };
          final Function1<EObject, JvmOperation> _function_3 = (EObject it) -> {
            return ((JvmOperation) it);
          };
          final Function1<JvmOperation, Boolean> _function_4 = (JvmOperation it) -> {
            return Boolean.valueOf(it.isStatic());
          };
          final Function1<JvmOperation, Boolean> _function_5 = (JvmOperation it) -> {
            boolean _xifexpression = false;
            boolean _isWildcard = id.isWildcard();
            if (_isWildcard) {
              _xifexpression = true;
            } else {
              _xifexpression = it.getSimpleName().equals(id.getMemberName());
            }
            return Boolean.valueOf(_xifexpression);
          };
          ProtelisScopeProvider.populateMethodReferences(IterableExtensions.<JvmOperation>filter(IterableExtensions.<JvmOperation>filter(IterableExtensions.<EObject, JvmOperation>map(IterableExtensions.<EObject>filter(type.eContents(), _function_2), _function_3), _function_4), _function_5), java);
        };
        javaImports.getImportDeclarations().forEach(_function_1);
      }
      final IScope plainProtelis = Scopes.scopeFor(internal);
      final SimpleScope refJava = new SimpleScope(java);
      final IScope outer = MapBasedScope.createScope(refJava, externalProtelis);
      final IScope final_ = MapBasedScope.createScope(outer, plainProtelis.getAllElements());
      _xblockexpression = final_;
    }
    return _xblockexpression;
  }
  
  public static void populateMethodReferences(final Iterable<JvmOperation> source, final Collection<IEObjectDescription> destination) {
    final Consumer<JvmOperation> _function = (JvmOperation it) -> {
      destination.add(ProtelisScopeProvider.generateDescription(it.getSimpleName(), it));
      destination.add(ProtelisScopeProvider.generateDescription(it.getQualifiedName().replace(".", "::"), it));
    };
    source.forEach(_function);
  }
  
  public static IEObjectDescription generateDescription(final String name, final EObject obj) {
    IEObjectDescription _xblockexpression = null;
    {
      final QualifiedName ref = QualifiedName.create(name);
      _xblockexpression = EObjectDescription.create(ref, obj);
    }
    return _xblockexpression;
  }
}
